%
% This script contains the solution to exercise 1, studying the stability
% of the bicycle problem. 
%

% Matrices from the paper
M  = [ 80.81722 2.31941332208709 ; 2.31941332208709 0.29784188199686 ];
C1 = [ 0 33.86641391492494 ; -0.85035641456978 1.68540397397560 ];
K0 = [ -80.95 -2.59951685249872 ; -2.59951685249872 -0.80329488458618];
K2 = [ 0 76.59734589573222 ; 0 2.65431523794604 ];

% Parameter dependent quadratic eigenvalue problem
C = @(v) v * C1;
K = @(v) v.^2 * K2 + 9.81 * K0;

% Function that describes the rightmost eigenvalue
f = chebfun(@(v) max(real(polyeig(K(v), C(v), M))), ...
	[0 10], 'splitting', 'on');

% Find the interval where the function is negative, and therefore the
% algorithm is stable
r = roots(f);

fprintf('The bicycle is stable for v in [%e, %e]\n', r(1), r(2));